SystemOrganization addCategory: #ConfigurationOfVillagesOfKhami!

Object subclass: #ConfigurationOfVillagesOfKhami
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfVillagesOfKhami'!

!ConfigurationOfVillagesOfKhami class methodsFor: 'development support' stamp: 'StuartHerring 4/10/2011 17:31'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfVillagesOfKhami class methodsFor: 'private' stamp: 'StuartHerring 4/10/2011 17:31'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfVillagesOfKhami class methodsFor: 'management' stamp: 'StuartHerring 4/10/2011 19:49'!
commitMessage
	^UIManager default multiLineRequest: 'Commit Message' centerAt:  nil initialAnswer:  '' answerHeight: 100! !

!ConfigurationOfVillagesOfKhami class methodsFor: 'private' stamp: 'StuartHerring 4/10/2011 17:31'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfVillagesOfKhami class methodsFor: 'private' stamp: 'StuartHerring 4/10/2011 17:31'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfVillagesOfKhami class methodsFor: 'metacello tool support' stamp: 'StuartHerring 4/10/2011 17:31'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfVillagesOfKhami class methodsFor: 'loading' stamp: 'StuartHerring 4/10/2011 17:31'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfVillagesOfKhami class methodsFor: 'loading' stamp: 'StuartHerring 4/10/2011 17:31'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfVillagesOfKhami class methodsFor: 'loading' stamp: 'StuartHerring 4/10/2011 17:31'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfVillagesOfKhami class methodsFor: 'accessing' stamp: 'StuartHerring 4/10/2011 17:31'!
project

	^self new project! !

!ConfigurationOfVillagesOfKhami class methodsFor: 'management' stamp: 'StuartHerring 4/10/2011 19:22'!
saveConfigurationPackage
	MetacelloToolBox 
		saveConfigurationPackageFor: 'VillagesOfKhami' 
		description: self commitMessage! !

!ConfigurationOfVillagesOfKhami class methodsFor: 'management' stamp: 'StuartHerring 4/10/2011 19:23'!
saveModifiedPackages
	MetacelloToolBox 
		saveModifiedPackagesIn: self
		description: self commitMessage! !

!ConfigurationOfVillagesOfKhami class methodsFor: 'management' stamp: 'StuartHerring 4/10/2011 19:22'!
saveModifiedPackagesAndConfiguration
	MetacelloToolBox 
		saveModifiedPackagesAndConfigurationIn: self
		description: self commitMessage! !

!ConfigurationOfVillagesOfKhami class methodsFor: 'management' stamp: 'StuartHerring 4/10/2011 19:27'!
updateToLatestPackageVersions
	(self project version: #bleedingEdge) load.
	MetacelloToolBox 
		updateToLatestPackageVersionsIn: self
		 description: (UIManager default request: 'Integration Message')! !

!ConfigurationOfVillagesOfKhami class methodsFor: 'development support' stamp: 'StuartHerring 4/10/2011 17:31'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfVillagesOfKhami methodsFor: 'baselines' stamp: 'StuartHerring 4/10/2011 20:44'!
baseline02: spec
	<version: '0.2-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://stuartherring.net/mc/Khami'.
		spec project: 'Seaside30' with: [
				spec
					className: 'ConfigurationOfSeaside30';
					versionString: '3.0.4';
					loads: #(
						'Base' 
						'Seaside-Adaptors-Comanche'
						'Javascript-Core' 
						'Prototype-Core' 
						'Scriptaculous-Core' 
						'Scriptaculous-Components');
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		spec project: 'Seaside30 Development' copyFrom: 'Seaside30' with: [
				spec
					loads: 'Development'].
		spec project: 'SIXX' with: [
				spec
					className: 'ConfigurationOfSIXX';
					versionString: '0.3.6';
					loads: #('Core');
					repository: 'http://www.squeaksource.com/MetacelloRepository'].
		spec 
			package: 'Khami-Core';
			package: 'Khami-Web' with: [
				spec requires: #('Seaside30' 'Khami-Core' 'SIXX'). ];
			package: 'Khami-Tools' with: [
				spec requires: #('Seaside30' ). ];
			package: 'Khami-Test' with: [
				spec requires: #('Khami-Core' 'Khami-Web' ). ].
		spec 
			group: 'default' with: #('Development' );
			group: 'Core' with: #('Khami-Web' );
			group: 'Development' with: #('Tests' 'DevDeployment' 'Seaside30 Development');
			group: 'Tests' with: #('Khami-Test' );
			group: 'DevDeployment' with: #('Core' 'Khami-Tools' ). ].
! !

!ConfigurationOfVillagesOfKhami methodsFor: 'baselines' stamp: 'StuartHerring 11/13/2011 13:46'!
baseline05: spec
	<version: '0.5-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://stuartherring.net/mc/Khami'.
		spec project: 'Seaside30' with: [
				spec
					className: 'ConfigurationOfSeaside30';
					versionString: '3.0.5';
					loads: #(
						'Base' 
						'Seaside-Adaptors-Comanche'
						'Javascript-Core' 
						'Prototype-Core' 
						'Scriptaculous-Core' 
						'Scriptaculous-Components');
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		spec project: 'Seaside30 Development' copyFrom: 'Seaside30' with: [
				spec
					loads: 'Development'].
		spec project: 'CloudforkSSO' with: [
				spec
					className: 'ConfigurationOfCloudforkSSO';
					versionString: '1.1.0';
					loads: #('Core');
					repository: 'http://www.squeaksource.com/Cloudfork' ].
		spec project: 'SIXX' with: [
				spec
					className: 'ConfigurationOfSIXX';
					versionString: '0.3.6';
					loads: #('Core');
					repository: 'http://www.squeaksource.com/MetacelloRepository'].
		spec project: 'Mocketry' with: [
				spec
					className: 'ConfigurationOfMocketry';
					versionString: '1.0';
					repository: 'http://www.squeaksource.com/MetacelloRepository'].
		spec
			package: 'Facebook' with: [
				spec requires: #('CloudforkSSO') ].
		spec 
			package: 'Khami-Core';
			package: 'Khami-Platform' with: [
				spec requires: #('Facebook') ];
			package: 'Khami-Web' with: [
				spec requires: #('Seaside30' 'Khami-Core' 'SIXX' 'Khami-Platform'). ];
			package: 'Khami-Tools' with: [
				spec requires: #('Seaside30' ). ];
			package: 'Khami-Test' with: [
				spec requires: #('Mocketry' 'Khami-Core' 'Khami-Web' ). ].
		spec 
			group: 'default' with: #('Development' );
			group: 'Core' with: #('Khami-Web' );
			group: 'Development' with: #('Tests' 'DevDeployment' 'Seaside30 Development');
			group: 'Tests' with: #('Khami-Test' );
			group: 'DevDeployment' with: #('Core' 'Khami-Tools' ). ].
! !

!ConfigurationOfVillagesOfKhami methodsFor: 'baselines' stamp: 'StuartHerring 11/20/2011 11:59'!
baseline06: spec
	<version: '0.6-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://stuartherring.net/mc/Khami'.
		spec project: 'Seaside30' with: [
				spec
					className: 'ConfigurationOfSeaside30';
					versionString: #stable;
					loads: #(
						'Base' 
						'Seaside-Adaptors-Comanche'
						'Javascript-Core' 
						'Prototype-Core' 
						'Scriptaculous-Core' 
						'Scriptaculous-Components'						
						'JQuery-UI' );
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		spec project: 'Seaside30 Development' copyFrom: 'Seaside30' with: [
				spec
					loads: 'Development'].
		spec project: 'CloudforkSSO' with: [
				spec
					className: 'ConfigurationOfCloudforkSSO';
					versionString: '1.1.0';
					loads: #('Core');
					repository: 'http://www.squeaksource.com/Cloudfork' ].
		spec project: 'SIXX' with: [
				spec
					className: 'ConfigurationOfSIXX';
					versionString: '0.3.6';
					loads: #('Core');
					repository: 'http://www.squeaksource.com/MetacelloRepository'].
		spec project: 'Mocketry' with: [
				spec
					className: 'ConfigurationOfMocketry';
					versionString: '1.0';
					repository: 'http://www.squeaksource.com/MetacelloRepository'].
		spec
			package: 'Facebook' with: [
				spec requires: #('CloudforkSSO') ].
		spec 
			package: 'Khami-Core';
			package: 'Khami-Platform' with: [
				spec requires: #('Facebook') ];
			package: 'Khami-Web' with: [
				spec requires: #('Seaside30' 'Khami-Core' 'SIXX' 'Khami-Platform'). ];
			package: 'Khami-Tools' with: [
				spec requires: #('Seaside30' ). ];
			package: 'Khami-Test' with: [
				spec requires: #('Mocketry' 'Khami-Core' 'Khami-Web' ). ].
		spec 
			group: 'default' with: #('Development' );
			group: 'Core' with: #('Khami-Web' );
			group: 'Development' with: #('Tests' 'DevDeployment' 'Seaside30 Development');
			group: 'Tests' with: #('Khami-Test' );
			group: 'DevDeployment' with: #('Core' 'Khami-Tools' ). ].
! !

!ConfigurationOfVillagesOfKhami methodsFor: 'baselines' stamp: 'StuartHerring 2/19/2012 19:01'!
baseline07: spec
	<version: '0.7-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://stuartherring.net/mc/Khami'.
		spec project: 'Seaside30' with: [
				spec
					className: 'ConfigurationOfSeaside30';
					versionString: #stable;
					loads: #(
						'Base' 
						'Seaside-Adaptors-Comanche'
						'Javascript-Core' 
						'Prototype-Core' 
						'Scriptaculous-Core' 
						'Scriptaculous-Components'						
						'JQuery-UI' );
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		spec project: 'Seaside30 Development' copyFrom: 'Seaside30' with: [
				spec
					loads: 'Development'].
		spec project: 'CloudforkSSO' with: [
				spec
					className: 'ConfigurationOfCloudforkSSO';
					versionString: '1.1.0';
					loads: #('Core');
					repository: 'http://www.squeaksource.com/Cloudfork' ].
		spec project: 'SIXX' with: [
				spec
					className: 'ConfigurationOfSIXX';
					versionString: '0.3.6';
					loads: #('Core');
					repository: 'http://www.squeaksource.com/MetacelloRepository'].
		spec project: 'Mocketry' with: [
				spec
					className: 'ConfigurationOfMocketry';
					versionString: '1.0';
					repository: 'http://www.squeaksource.com/MetacelloRepository'].
		spec
			package: 'Facebook' with: [
				spec requires: #('CloudforkSSO') ].
		spec 
			package: 'Khami-Core';
			package: 'Khami-Platform' with: [
				spec requires: #('Seaside30')];
			package: 'Khami-Integration-Facebook' with: [
				spec requires: #('Khami-Platform' 'Facebook') ];
			package: 'Khami-Web' with: [
				spec requires: #('Seaside30' 'Khami-Core' 'SIXX' 'Khami-Platform'). ];
			package: 'Khami-Tools' with: [
				spec requires: #('Seaside30' ). ];
			package: 'Khami-Test' with: [
				spec requires: #('Mocketry' 'Khami-Core' 'Khami-Web' ). ].
		spec 
			group: 'default' with: #('Development' );
			group: 'Platform' with: #('Khami-Platform');
			group: 'Platform Test' with: #('Platform' 'Mocketry');
			group: 'Facebook Integration' with: #('Khami-Integration-Facebook');
			group: 'Core' with: #('Khami-Web' 'Platform' 'Facebook Integration' );
			group: 'Development' with: #('Tests' 'DevDeployment' 'Seaside30 Development');
			group: 'Tests' with: #('Khami-Test' );
			group: 'DevDeployment' with: #('Core' 'Khami-Tools' ). ].
! !

!ConfigurationOfVillagesOfKhami methodsFor: 'symbolic versions' stamp: 'StuartHerring 5/22/2012 21:35'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: #'notDefined'.
! !

!ConfigurationOfVillagesOfKhami methodsFor: 'accessing' stamp: 'StuartHerring 4/10/2011 17:31'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfVillagesOfKhami methodsFor: 'symbolic versions' stamp: 'StuartHerring 5/22/2012 21:35'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '0.6.1'.
! !

!ConfigurationOfVillagesOfKhami methodsFor: 'versions' stamp: 'StuartHerring 5/15/2011 11:10'!
version025: spec
	<version: '0.25' imports: #('0.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec description: 'Initial development configuration
Upgrading
Changed internal representation to a 17 segment model instead of 13, updated UI.
Implemented half-village which now allows the starting tile to be implemented
Display changes
Implemented support for 13 character strings and removed the lowercase v notation - makes defining correct tiles more convenient.

Also ensured that two walled villages can connect if not on the same tile.
KMI-47

Fixed handling of | character
KMI-48

Remove caching of completeness from KmTerritory, the order of events seem to have been telling the territory that it was complete when it was not.
KMI-49

Added corner images
KMI-49

Fixed a couple of minor display issues.
KMI-18
Implemented basic assertions regarding pieces.
KMI-18

Fulfilled additional requirements regarding blocker segments
KMI-17

Implemented Player requirements. 
Fixed a few more Lint issues
KMI-52

Completely re-structured the way the game is controlled.  All game control is now done via the Task - no actions that affect gameplay are performed by the screens themselves, they just return the required information to make it happen.
Added two default players to the game and implemented display and placement of pieces.  Still need to handle running out of pieces, etc.
KMI-53
KMI-54

Player information added
KMI-55

First refactoring before implementing scoring - created parallel Territory heirarchy to Segments
KMI-55

Major refactoring complete - removed KmTileSegment subclasses entirely and delegated their functionality to the appropriate Territory
KMI-55

Massive changes to the Locations - made everything calculated rather than hard-coded.
Mostly so as to avoid the 10 minutes it would take to manually add the adjacentLocations methods - That was 4 hours well spent.

Scoring should now work properly for Farms, Villages and Roads.
Just huts to do now.
KMI-55

Scoring complete!!
No need to have calculateScore on KmTile - KmGame calls it on KmTerritory directly.'.
		spec author: 'StuartHerring'.
		spec timestamp: '5/14/2011 23:07'.
		spec 
			package: 'Khami-Core' with: 'Khami-Core-StuartHerring.54';
			package: 'Khami-Web' with: 'Khami-Web-StuartHerring.46';
			package: 'Khami-Tools' with: 'Khami-Tools-StuartHerring.2';
			package: 'Khami-Test' with: 'Khami-Test-StuartHerring.52'. ].
! !

!ConfigurationOfVillagesOfKhami methodsFor: 'versions' stamp: 'StuartHerring 8/7/2011 17:05'!
version04: spec
	<version: '0.4' imports: #('0.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec description: 'Starting work on Milestone 4
KMI-11, KMI-12, KMI-13

Major progress towards multiplayer.
Created player accounts and a basic dashboard.
Players can now create, list join and start games.

Next is to create game view task (based on old hotseat version)
KMI-12, KMI-13

Basic network multiplayer now functional - can list games, start games, and join games.
Can go back and look at old games.
Fix failing tests - ensure KmUser>>printOn: handles a nil username'.
		spec author: 'StuartHerring'.
		spec timestamp: '7/6/2011 23:24'.
		spec 
			package: 'Khami-Core' with: 'Khami-Core-StuartHerring.58';
			package: 'Khami-Web' with: 'Khami-Web-StuartHerring.49';
			package: 'Khami-Tools' with: 'Khami-Tools-StuartHerring.3';
			package: 'Khami-Test' with: 'Khami-Test-StuartHerring.54'. ].
! !

!ConfigurationOfVillagesOfKhami methodsFor: 'versions' stamp: 'StuartHerring 11/20/2011 11:39'!
version05: spec
	<version: '0.5' imports: #('0.5-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec description: 'Start work on Facebook integration
Implemented basic Internal platform type, and converted Application to use the platform
Added Mocketry as a dependency of Test
Added default configuration for Internal platform
Started implementing Facebook platform
KMI-65.

Facebook integration now integrated.
Remove breakpoint that shouldn''t have been there'.
		spec author: 'StuartHerring'.
		spec timestamp: '11/19/2011 15:16'.
		spec 
			package: 'Facebook' with: 'Facebook-StuartHerring.5';
			package: 'Khami-Core' with: 'Khami-Core-StuartHerring.61';
			package: 'Khami-Platform' with: 'Khami-Platform-StuartHerring.3';
			package: 'Khami-Web' with: 'Khami-Web-StuartHerring.52';
			package: 'Khami-Tools' with: 'Khami-Tools-StuartHerring.3';
			package: 'Khami-Test' with: 'Khami-Test-StuartHerring.57'. ].
! !

!ConfigurationOfVillagesOfKhami methodsFor: 'versions' stamp: 'StuartHerring 5/22/2012 21:35'!
version061: spec
	<version: '0.6.1' imports: #('0.7-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec description: 'New version after modifying baseline configuration
Reorganised platform packages to better facilitate external reuse.

Minor fixes to the baseline
Moved Platform tests into Platform itself
Esnure Facebook tests aren''t in the regular Platform tests
Make tests pass, and ensure that internal users are equal when their username is equal
SC-27
Added removeUser and removeSessionsForUser methods to the session and user registries
Improve debug display of users
SC-27
Make SPInternalSession store userId not the full user - require SPPlatform to therefore have access to a userRegistry
SC-27
Ensure UserRegistry uses #id not #name when looking and adding users'.
		spec author: 'StuartHerring'.
		spec timestamp: '5/20/2012 18:39'.
		spec 
			package: 'Facebook' with: 'Facebook-StuartHerring.5';
			package: 'Khami-Core' with: 'Khami-Core-StuartHerring.63';
			package: 'Khami-Platform' with: 'Khami-Platform-StuartHerring.13';
			package: 'Khami-Integration-Facebook' with: 'Khami-Integration-Facebook-StuartHerring.2';
			package: 'Khami-Web' with: 'Khami-Web-StuartHerring.53';
			package: 'Khami-Tools' with: 'Khami-Tools-StuartHerring.3';
			package: 'Khami-Test' with: 'Khami-Test-StuartHerring.60'. ].
! !

!ConfigurationOfVillagesOfKhami methodsFor: 'versions' stamp: 'StuartHerring 2/19/2012 18:20'!
version06: spec
	<version: '0.6' imports: #('0.6-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec description: '- Start work on milestone 6
Work towards new interface
Make tests pass (implement removePlayer: properly)'.
		spec author: 'StuartHerring'.
		spec timestamp: '2/19/2012 18:20'.
		spec 
			package: 'Facebook' with: 'Facebook-StuartHerring.5';
			package: 'Khami-Core' with: 'Khami-Core-StuartHerring.63';
			package: 'Khami-Platform' with: 'Khami-Platform-StuartHerring.4';
			package: 'Khami-Web' with: 'Khami-Web-StuartHerring.53';
			package: 'Khami-Tools' with: 'Khami-Tools-StuartHerring.3';
			package: 'Khami-Test' with: 'Khami-Test-StuartHerring.59'. ].
! !
